unit UnitTwain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MultiTWAIN, Menus, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SelectSource1: TMenuItem;
    Accquire1: TMenuItem;
    Hcm: TLabel;
    Label1: TLabel;
    Wcm: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Colors: TLabel;
    Image1: TImage;
    procedure File1Click(Sender: TObject);
    procedure Accquire1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var
MyBitMap: TBitMap;

procedure TForm1.File1Click(Sender: TObject);
begin
  {  }
  TWAIN_SelectImageSource(Handle);
end;

procedure TForm1.Accquire1Click(Sender: TObject);
var
 dat: hBitMap;
 PInfo: PBitMapInfoHeader;
 Height,Width:integer;
{  2  }
function stp2(s:byte):longint;
 var
  m: longint;
  i: byte;
 begin
  m:=2;
  for i:=2 to s do m:=m*2;
  stp2:=m;
 end;

begin
 {    }
 dat:=TWAIN_AcquireNative(Handle,0);
 if dat <> 0 then begin
  {      DIB
       }
  PInfo:=GlobalLock(dat);
  {  }
  Height:=PInfo.biHeight ;
  Width:=PInfo.biWidth ;
  Wcm.Caption :=floatToStrF(100/PInfo.biXPelsPerMeter*Width,ffNumber,8,3)+' cm';
  Hcm.Caption :=floatToStrF(100/PInfo.biYPelsPerMeter*Height,ffNumber,8,3)+' cm';
  Colors.Caption := floatToStrF(stp2(PInfo.biBitCount),ffNumber,8,0)+ ' ';
  { }
  GlobalUnlock(dat);
  {     }
  {   }
  try
   MyBitMap.Palette :=TWAIN_CreateDibPalette(dat);
   MyBitMap.Width := Width;
   MyBitMap.Height := Height;
   TWAIN_DrawDibToDC(MyBitMap.Canvas.Handle,0,0,Width,Height,dat,0,0);
  except
   {        
      }
   on EOutOFResources do
      MessageDlg('TBitMap:     !',
                 mtError,[mbOk],0);
  end;
   {  }
   //Canvas.Draw(10,10,MyBitMap);
   Image1.Picture.Graphic:=MyBitMap;
   {    }
   TWAIN_FreeNative(dat);
 end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 {  }
 MyBitMap:=TBitMap.Create; 
end;

end.
